#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

void convert(char **argv)
{
  FILE *f;
  int    q1[10000];
  int    q2[10000];
  int    q3[10000];
  int    q4[10000];
  double p1[10000];
  double p2[10000];
  double p3[10000];
  int i, numquads, numpoints,tmp;
  char fname[1024];

  sprintf(fname,"%s",argv[1]);
  f=fopen(fname,"r");
  assert(f);

  fscanf(f,"%d\n",&numquads);
  for(i=0;i<numquads;i++)
    {
      fscanf(f,"%d %d %d %d\n",&q1[i],&q2[i],&q3[i],&q4[i]);
      //printf("%d %d %d %d\n",q1[i],q2[i],q3[i],q4[i]);
    }

  fscanf(f,"%d\n",&numpoints);
  for(i=0;i<numpoints;i++)
    {
      fscanf(f,"%d %le %le %le\n,",&tmp, &p1[i],&p2[i],&p3[i]);
    }
  printf("#Inventor V2.0 ascii\nSeparator{Material{ambientColor 0.8 0.8 0.9 diffuseColor 0.8 0.8 0.9}Coordinate3{point [\n");
  for(i=0;i<numpoints;i++)
    {
      printf("%e %e %e",p1[i],p2[i],p3[i]);
      if(i!=numpoints-1) printf(",\n");
      else printf("\n");
    }
  printf("]}\n");
  printf("IndexedFaceSet{coordIndex[\n");
  for(i=0;i<numquads;i++)
    {
      printf("%d,%d,%d,%d,-1",q1[i],q2[i],q3[i],q4[i]);
      if(i!=numquads-1) printf(",\n");
      else printf("\n");
    }
  printf("]}}\n");
}

int main(int argc, char ** argv)
{
  if(argc!=2)
    {
      printf("%s infile.cub\n",argv[0]);
      exit(1);
    }

  convert(argv);
}
