//////////////////////////////////////////////////////////////////////////
//
// List.h, Ilja Friedel, 06/22/02
//
//////////////////////////////////////////////////////////////////////////

#ifndef LIST_DEF
#define LIST_DEF 1

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <iostream>

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

class Node;

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

class ListElement
{
 public:

  Node        *data;
  ListElement *next;
  ListElement *prev;

  ListElement(Node *O, ListElement *n, ListElement *p)
    {
      data=O;
      next=n;
      prev=p;
    }
};

//////////////////////////////////////////////////////////////////////////

class List
{
  ListElement *head_;
  ListElement *tail_;
  int          NumElements_;

 public:

  void         remove(Node* O);
  void         append(Node* O);
  ListElement* head(void);
  ListElement* tail(void);
  ListElement* find(Node* O);

  int NumElements(void)
    {
      return(NumElements_);
    }

  void print(void);
  
  virtual      ~List();
               List();
};

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
#endif
